      subroutine rndseq ( value, multiplier, increment, modulus )
      integer*4 value, multiplier, increment, modulus
      value = mod ( value * multiplier + increment, modulus )
      return
      end
      subroutine rndini ( seed1, seed2 )
      integer seed1, seed2
      integer idx
      integer now(7)
      integer*4 value1, value2, mult1, mult2, inc1, inc2, modu1, modu2, 
     *table
      common /rndcom/ value1, value2, mult1, mult2, inc1, inc2,modu1, 
     *modu2, table(200)
      mult1 = 1541
      inc1 = 3501
      modu1 = 16384
      mult2 = 5146
      inc2 = 4100
      modu2 = 19683
      call getnow ( now )
      if (.not.( seed1 .ne. 0 ))goto 23000
      value1 = seed1
      goto 23001
23000 continue
      value1 = ( ( now(3) * 10 + now(4) ) * 10 + now(5) ) * 10 + now(6)
23001 continue
      value1 = mod ( value1, modu1 )
      if (.not.( seed2 .ne. 0 ))goto 23002
      value2 = seed2
      goto 23003
23002 continue
      value2 = ( ( now(6) * 10 + now(5) ) * 10 + now(4) ) * 10 + now(3)
23003 continue
      value2 = mod ( value2, modu2 )
      idx=1
23004 if (.not.(idx .le. 200))goto 23006
      call rndseq ( value2, mult2, inc2, modu2 )
      table(idx) = value2
23005 idx=idx+1 
      goto 23004
23006 continue
      return
      end
      real function rnd ( dummy )
      integer dummy
      integer idx
      integer*4 value1, value2, mult1, mult2, inc1, inc2, modu1, modu2, 
     *table
      common /rndcom/ value1, value2, mult1, mult2, inc1, inc2,modu1, 
     *modu2, table(200)
      call rndseq ( value1, mult1, inc1, modu1 )
      idx = ifix ( float(value1) / float(modu1) * 200 ) + 1
      rnd = float(table(idx)) / float(modu2)
      call rndseq ( value2, mult2, inc2, modu2 )
      table(idx) = value2
      return
      end
      real function rnduni ( rlow, rhigh )
      real rlow, rhigh
      real rnd
      rnduni = rnd(0) * (rhigh-rlow) + rlow
      return
      end
      integer function rndint ( ilow, ihigh )
      integer ilow, ihigh
      real rnd
      rndint = ifix ( rnd(0) * float(ihigh-ilow+1) ) + ilow
      return
      end
      real function rndnor ( mean, stddev )
      real mean, stddev
      real rnd, v1, v2, z
23007 continue
      v1 = -alog(1.0-rnd(0))
      v2 = -alog(1.0-rnd(0))
23008 if (.not.( 2.0*v1 .ge. (v2-1.0)**2 ))goto 23007
23009 continue
      if (.not.( rnd(0) .gt. 0.5 ))goto 23010
      z = 1.0
      goto 23011
23010 continue
      z = -1.0
23011 continue
      rndnor = stddev * z * v2 + mean
      return
      end
      real function rndexp ( mean )
      real mean
      real rnd
      rndexp = - alog ( 1.0 - rnd(0) ) * mean
      return
      end
      real function rndchi ( v )
      integer v
      integer k, x
      real rndexp, rndnor
      k = v / 2
      rndchi = 0.0
      x=1
23012 if (.not.(x .le. k))goto 23014
      rndchi = rndchi + rndexp ( 1.0 )
23013 x=x+1 
      goto 23012
23014 continue
      rndchi = rndchi * 2.0
      if (.not.( k * 2 + 1 .eq. v ))goto 23015
      rndchi = rndchi + rndnor(0.0,1.0)**2
23015 continue
      return
      end
      real function rndbta ( v1, v2 )
      integer v1, v2
      real y1, y2, rndchi
      y1 = rndchi ( v1 )
      y2 = rndchi ( v2 )
      rndbta = y1 / (y1+y2)
      return
      end
      real function rndF ( v1, v2 )
      integer v1, v2
      real y1, y2, rndchi
      y1 = rndchi ( v1 )
      y2 = rndchi ( v2 )
      rndF = (y1*v2) / (y2*v1)
      return
      end
      real function rndt ( v )
      integer v
      real y1, y2, rndnor, rndchi
      y1 = rndnor ( 0.0, 1.0 )
      y2 = rndchi ( v )
      rndt = y1 / sqrt ( y2/v )
      return
      end
      integer function rndgeo ( prob )
      real prob
      real rnd
      if (.not.( prob .lt. 0.0 .or. prob .gt. 1.0 ))goto 23017
      rndgeo = 0
      goto 23018
23017 continue
      if (.not.( prob .eq. 1.0 ))goto 23019
      rndgeo = 1
      goto 23020
23019 continue
      rndgeo = aint ( alog(1.0-rnd(0)) / alog(1.0-prob) + 0.999999 )
23020 continue
23018 continue
      return
      end
      integer function rndbin ( trials, prob )
      integer trials
      real prob
      integer i
      real rnd
      rndbin = 0
      i=1
23021 if (.not.(i .le. trials))goto 23023
      if (.not.( rnd(0) .le. prob ))goto 23024
      rndbin = rndbin + 1
23024 continue
23022 i=i+1 
      goto 23021
23023 continue
      return
      end
      integer function rndpoi ( mean )
      real mean
      real p, q, rnd
      p = exp ( -mean )
      rndpoi = 0
      q = 1.0
23026 continue
      q = q * rnd(0)
      if (.not.( q .lt. p ))goto 23029
      goto 23028
23029 continue
      rndpoi = rndpoi + 1
23027 goto 23026
23028 continue
      return
      end
